/***************************************************************************************************
	 2022 RSM US LLP  All rights reserved.

RSM US LLP (RSM) grants to Client a limited, non-exclusive, non-transferable right to install and
use the Software/Source Code solely for internal business purposes.  Client may not distribute,
give, rent, loan, or resell a copy of the Software/Source Code to any third party. RSM is the owner 
of the copyright for the Software/Source Code and RSM reserves all rights related to such ownership.
Any Warranty granted by RSM is void if Software/Source Code is modified by anyone other than RSM.

$URL: https://svn.rsm.cloud/repos/NonClient/wvSuite/trunk/SQL/Extract_referenced_GenTables.sql $
$Rev: 20637 $
$Date: 2022-06-04 21:18:56 -0500 (Sat, 04 Jun 2022) $
***************************************************************************************************/
-- This is an adhoc script for extracting the CCW information and the related Gen_Tables data
-- The output is a SQL script which can be run in another database

exec pr_wv_SortCCW
go
set nocount on
go

/* A script which can help to find fields that have changes

select
		isnull(src.PAGEPART, dest.PAGEPART) 'PAGEPART',
		isnull(src.DEMOG_TABLE_NAME, dest.DEMOG_TABLE_NAME) 'Table',
		isnull(src.FIELD_NAME, dest.FIELD_NAME) 'FIELD_NAME',
		src.PROMPT, dest.PROMPT,
		src.SORT_POSITION, dest.SORT_POSITION,
		src.FIELD_REQUIRED, dest.FIELD_REQUIRED,
		-- src.NEW_COLUMN, dest.NEW_COLUMN,
		src.TOOLTIP, dest.TOOLTIP,
		src.DESCRIPTION_BEFORE, dest.DESCRIPTION_BEFORE,
		src.DESCRIPTION_AFTER, dest.DESCRIPTION_AFTER,
		src.CUSTOM_CSS, dest.CUSTOM_CSS,
		src.VALIDATION_TYPE, dest.VALIDATION_TYPE,
		src.VALIDATION_TABLE, dest.VALIDATION_TABLE,
		src.DEFAULT_VALUE_FUNCTION, dest.DEFAULT_VALUE_FUNCTION,
		src.ALLOW_MARKUP, dest.ALLOW_MARKUP,
		src.RANGE_MINIMUM, dest.RANGE_MINIMUM,
		src.RANGE_MAXIMUM, dest.RANGE_MAXIMUM,
		src.NUMERIC_INCREMENT, dest.NUMERIC_INCREMENT,
		src.ROLES_REQUIRED_EDIT, dest.ROLES_REQUIRED_EDIT,
		src.ROLES_REQUIRED_EDIT_NEW, dest.ROLES_REQUIRED_EDIT_NEW,
		src.ROLES_REQUIRED_VIEW, dest.ROLES_REQUIRED_VIEW,
		src.ROLES_REQUIRED_VIEW_NEW, dest.ROLES_REQUIRED_VIEW_NEW
	from imis_dev..Config_Custom_Web src
	full outer join imis_live..Config_Custom_Web dest
		on src.PAGEPART = dest.PAGEPART
		and src.DEMOG_TABLE_NAME = dest.DEMOG_TABLE_NAME
		and src.FIELD_NAME = dest.FIELD_NAME
	where src.DEMOG_TABLE_NAME is null
		or dest.DEMOG_TABLE_NAME is null
		or isnull(src.PROMPT, '') != isnull(dest.PROMPT, '')
-- Comment out the next line to ignore fields which only changed position
		or isnull(src.SORT_POSITION, 0) != isnull(dest.SORT_POSITION, 0)
		or isnull(src.FIELD_REQUIRED, 0) != isnull(dest.FIELD_REQUIRED, 0)
		--or isnull(src.NEW_COLUMN, 0) != isnull(dest.NEW_COLUMN, 0)
		or isnull(src.TOOLTIP, '') != isnull(dest.TOOLTIP, '')
		or isnull(src.DESCRIPTION_BEFORE, '') != isnull(dest.DESCRIPTION_BEFORE, '')
		or isnull(src.DESCRIPTION_AFTER, '') != isnull(dest.DESCRIPTION_AFTER, '')
		or isnull(src.CUSTOM_CSS, '') != isnull(dest.CUSTOM_CSS, '')
		or isnull(src.VALIDATION_TYPE, '') != isnull(dest.VALIDATION_TYPE, '')
		or isnull(src.VALIDATION_TABLE, '') != isnull(dest.VALIDATION_TABLE, '')
		or isnull(src.DEFAULT_VALUE_FUNCTION, '') != isnull(dest.DEFAULT_VALUE_FUNCTION, '')
		or isnull(src.ALLOW_MARKUP, 0) != isnull(dest.ALLOW_MARKUP, 0)
		or isnull(src.RANGE_MINIMUM, '') != isnull(dest.RANGE_MINIMUM, '')
		or isnull(src.RANGE_MAXIMUM, '') != isnull(dest.RANGE_MAXIMUM, '')
		or isnull(src.NUMERIC_INCREMENT, 0) != isnull(dest.NUMERIC_INCREMENT, 0)
		or isnull(src.ROLES_REQUIRED_EDIT, '') != isnull(dest.ROLES_REQUIRED_EDIT, '')
		or isnull(src.ROLES_REQUIRED_EDIT_NEW, '') != isnull(dest.ROLES_REQUIRED_EDIT_NEW, '')
		or isnull(src.ROLES_REQUIRED_VIEW, '') != isnull(dest.ROLES_REQUIRED_VIEW, '')
		or isnull(src.ROLES_REQUIRED_VIEW_NEW, '') != isnull(dest.ROLES_REQUIRED_VIEW_NEW, '')
	order by PAGEPART, src.SORT_POSITION, FIELD_NAME
*/


select '-- Config_Custom_Web
-- server ' + @@servername + '
-- database ' + db_name() + '
-- date ' + convert(varchar, getdate()) + '

declare @id varchar(10), @seqnoffset int
select @id = ID from dbo.Name where MEMBER_TYPE = ''_CFG''
select @seqnoffset = max(SEQN) from dbo.Config_Custom_Web where ID = @id

INSERT INTO Config_Custom_Web (SEQN, ID, DEMOG_TABLE_NAME, FIELD_NAME, FIELD_REQUIRED, CUSTOM_CSS, DEFAULT_VALUE_FUNCTION,
	DESCRIPTION_BEFORE, DESCRIPTION_AFTER, PAGEPART, PROMPT, SHOW_IN_GRID, SORT_POSITION, ROLES_REQUIRED_EDIT,
	ROLES_REQUIRED_EDIT_NEW, ROLES_REQUIRED_VIEW, ROLES_REQUIRED_VIEW_NEW, TOOLTIP, VALIDATION_TABLE, VALIDATION_TYPE,
	ALLOW_MARKUP, RANGE_MINIMUM, RANGE_MAXIMUM, NUMERIC_INCREMENT, SELECTOR_SINGLE, SELECTOR_PARENT)
values'

select '(@seqnoffset + '
		+ convert(varchar(10), row_number() over (order by SEQN)) 
		+ ', @id, '''
		+ DEMOG_TABLE_NAME + ''', ''' 
		+ FIELD_NAME + ''', ' 
		+ convert(varchar, FIELD_REQUIRED) + ', '
		+ convert(varchar, NEW_COLUMN) + ', '''
		+ CUSTOM_CSS + ''', '''
		+ DEFAULT_VALUE_FUNCTION + ''', '''
		+ replace(isnull(convert(varchar(max), DESCRIPTION_BEFORE), ''), '''', '''''') + ''', ''' 
		+ replace(isnull(convert(varchar(max), DESCRIPTION_AFTER), ''), '''', '''''') + ''', '''
		+ PAGEPART + ''', ''' 
		+ replace(PROMPT, '''', '''''') + ''', ' 
		+ convert(varchar, SHOW_IN_GRID) + ', ' 
		+ convert(varchar, SORT_POSITION) + ', ''' 
		+ ROLES_REQUIRED_EDIT + ''', ''' 
		+ ROLES_REQUIRED_EDIT_NEW + ''', ''' 
		+ ROLES_REQUIRED_VIEW + ''', ''' 
		+ ROLES_REQUIRED_VIEW_NEW + ''', ''' 
		+ replace(TOOLTIP, '''', '''''') + ''', ''' 
		+ VALIDATION_TABLE + ''', ''' 
		+ VALIDATION_TYPE + ''', '
		+ convert(varchar,ALLOW_MARKUP) + ', '''
		+ convert(varchar,RANGE_MINIMUM) + ''', '''
		+ convert(varchar,RANGE_MAXIMUM) + ''', '
		+ convert(varchar,NUMERIC_INCREMENT) + ', '''
		+ replace(SELECTOR_SINGLE, '''', '''''') + ''', '''
		+ replace(SELECTOR_PARENT, '''', '''''') 
		+ '''),'
	from dbo.Config_Custom_Web
	order by SEQN

print ''
print '-- Rows were inserted without use of Counter table, so sort now.'
print 'exec dbo.pr_wv_SortCCW'
go

select 'insert dbo.Gen_Tables (TABLE_NAME, CODE, UPPER_CODE, SUBSTITUTE, DESCRIPTION) select ''' + TABLE_NAME + ''', ''' + CODE + ''', ''' + UPPER_CODE + ''', ''' + SUBSTITUTE + ''', ''' + replace(DESCRIPTION, '''', '''''') + ''' where not exists (select 1 from dbo.Gen_Tables where TABLE_NAME = ''' + TABLE_NAME + ''' and CODE = ''' + CODE + ''');
go'
	from dbo.Gen_Tables
	where TABLE_NAME in (select distinct VALIDATION_TABLE from dbo.Config_Custom_Web where VALIDATION_TYPE = 'GENTABLE')
		or TABLE_NAME in ('CCW_PAGEPART', 'CCW_PAGEPART_POSTSAVE', 'CCW_PAGEPRIMARYTABLE', 'CCW_SUBMISSION_STATUS_ACCESS')
		or TABLE_NAME in (select distinct VALIDATION_TABLE from dbo.UD_Field where VALIDATION_TABLE != '' and TABLE_NAME = 'Config_Custom_Web')
		or TABLE_NAME in (select distinct VALIDATION_TABLE from dbo.UD_Field where VALIDATION_TABLE != '' and TABLE_NAME in (select distinct DEMOG_TABLE_NAME from dbo.Config_Custom_Web where VALIDATION_TYPE = 'GENTABLE'))
	order by TABLE_NAME, CODE
